package samples.catchtherain;

import java.awt.*;

/**
 * A rain drop for CatchTheRain program
 */

public class RainDrop {
    private final double x;     // x and y for center
    private double y;
    private final double dy;    // NO getter
    private final double radius;
    private final Color color;

    public RainDrop(double x, double y, double radius, double dy, Color color) {
        this.x = x;
        this.y = y;
        this.dy = dy;
        this.radius = radius;
        this.color = color;
    }

    public void move() {
        y -= dy;
    }

    public Rectangle getBoundingBox() {
        int x = (int) (this.x - radius);
        int y = (int) (this.y + radius);
        int h = (int) (2 * radius);
        int w = (int) (2 * radius);
        return new Rectangle(x, y, w, h);
    }

    public Color getColor() {
        return color;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public double getRadius() {
        return radius;
    }
}